
#include "LCD_2x16.h"
#include "gpio.h"
#include "tim.h"

#define LCD_RD7     GPIO_PIN_7     // D7
#define LCD_RD6     GPIO_PIN_6     // D6
#define LCD_RD5     GPIO_PIN_5     // D5
#define LCD_RD4     GPIO_PIN_4     // D4
#define LCD_EN      GPIO_PIN_1     // EN
#define LCD_RS      GPIO_PIN_0     // RS

/*
0b10000000 = 0x80
0b01000000 = 0x40
0b00100000 = 0x20
0b00010000 = 0x10
0b00001000 = 0x08
0b00000100 = 0x04
0b00000010 = 0x02
0b00000001 = 0x01
*/

void Lcd_Init(){
	
unsigned char data1;

HAL_GPIO_WritePin(GPIOA,  LCD_RD7|LCD_RD6|LCD_RD5| LCD_RD4, GPIO_PIN_RESET);
HAL_GPIO_WritePin(GPIOB, LCD_RS|LCD_EN, GPIO_PIN_RESET);
HAL_Delay(33); 

for(data1 = 1; data1 < 4; data1 ++)
{
    /*LCD_RD7 = 0;   LCD_RD6 = 0;    LCD_RD5 = 1;    LCD_RD4 = 1;    LCD_EN = 0;
    LCD_RS = 0;    LCD_RD7 = 0;    LCD_RD6 = 0;    LCD_RD5 = 1;    LCD_RD4 = 1;
    LCD_EN = 1;    LCD_RS = 0; */  
    HAL_GPIO_WritePin(GPIOA, LCD_RD7|LCD_RD6, GPIO_PIN_RESET);
	  HAL_GPIO_WritePin(GPIOA, LCD_RD5|LCD_RD4, GPIO_PIN_SET);
    HAL_GPIO_WritePin(GPIOB, LCD_RS|LCD_EN, GPIO_PIN_RESET);
	  HAL_GPIO_WritePin(GPIOA, LCD_RD7|LCD_RD6, GPIO_PIN_RESET);
	  HAL_GPIO_WritePin(GPIOA, LCD_RD5|LCD_RD4, GPIO_PIN_SET);
	  HAL_GPIO_WritePin(GPIOB, LCD_EN, GPIO_PIN_SET);
	  HAL_GPIO_WritePin(GPIOB, LCD_RS, GPIO_PIN_RESET);
	  delay_us(5);
  /*  LCD_RD7 = 0;   LCD_RD6 = 0;    LCD_RD5 = 1;    LCD_RD4 = 1;    LCD_EN = 0;
    LCD_RS = 0; */   
	HAL_GPIO_WritePin(GPIOA,  LCD_RD7|LCD_RD6, GPIO_PIN_RESET);
	HAL_GPIO_WritePin(GPIOA, LCD_RD5|LCD_RD4, GPIO_PIN_SET);
  HAL_GPIO_WritePin(GPIOB, LCD_RS|LCD_EN, GPIO_PIN_RESET);
	delay_us(5500);

}
/*LCD_RD7 = 0; LCD_RD6 = 0; LCD_RD5 = 1; LCD_RD4 = 0; LCD_EN = 0; LCD_RS = 0;
LCD_RD7 = 0; LCD_RD6 = 0; LCD_RD5 = 1; LCD_RD4 = 0; LCD_EN = 1; LCD_RS = 0;*/
HAL_GPIO_WritePin(GPIOA, LCD_RD7|LCD_RD6, GPIO_PIN_RESET);
HAL_GPIO_WritePin(GPIOA, LCD_RD5, GPIO_PIN_SET);
HAL_GPIO_WritePin(GPIOA, LCD_RD4, GPIO_PIN_RESET);
HAL_GPIO_WritePin(GPIOB, LCD_RS|LCD_EN, GPIO_PIN_RESET);
HAL_GPIO_WritePin(GPIOA, LCD_RD7|LCD_RD6, GPIO_PIN_RESET);
HAL_GPIO_WritePin(GPIOA, LCD_RD5, GPIO_PIN_SET);
HAL_GPIO_WritePin(GPIOA, LCD_RD4, GPIO_PIN_RESET);
HAL_GPIO_WritePin(GPIOB, LCD_EN, GPIO_PIN_SET);
HAL_GPIO_WritePin(GPIOB, LCD_RS, GPIO_PIN_RESET);
delay_us(5);
/*
LCD_RD7 = 0; LCD_RD6 = 0; LCD_RD5 = 1; LCD_RD4 = 0; LCD_EN = 0; LCD_RS = 0;*/
HAL_GPIO_WritePin(GPIOA, LCD_RD7|LCD_RD6, GPIO_PIN_RESET);
HAL_GPIO_WritePin(GPIOA, LCD_RD5, GPIO_PIN_SET);
HAL_GPIO_WritePin(GPIOA, LCD_RD4, GPIO_PIN_RESET);
HAL_GPIO_WritePin(GPIOB, LCD_RS|LCD_EN, GPIO_PIN_RESET);
delay_us(5500);

Lcd_Cmd(LCD_RETURN_HOME);
Lcd_Cmd(LCD_FOR_2LINE);
Lcd_Cmd(LCD_CLEAR);
Lcd_Cmd(LCD_DIRECTION);
Lcd_Cmd(LCD_CURSOR_OFF);

}
void Lcd_One_Char(unsigned char P, unsigned char L, char ch)
{
unsigned char data1;
switch (P)
{
    case 1: data1 = 0x80 + L; break;
    case 2: data1 = 0xC0 + L; break;
    case 3: data1 = 0x94 + L; break;
    case 4: data1 = 0xD4 + L; break;
    default: break;
}
Lcd_Cmd(data1);
Lcd_Chr_CP(ch);
return;
}

void Lcd_Out(unsigned char P, unsigned char L, char *buffer)
{
unsigned char data1;
switch (P)
{
    case 1: data1 = 0x80 + L; break;
    case 2: data1 = 0xC0 + L; break;
    case 3: data1 = 0x94 + L; break;
    case 4: data1 = 0xD4 + L; break;
    default: break;
}
Lcd_Cmd(data1);
while(*buffer)              // Write data to LCD up to null
{
    Lcd_Chr_CP(*buffer);
    buffer++;               // Increment buffer
}
return;
}

void Lcd_Chr_CP(char data1){

//LCD_EN = 0; LCD_RS = 1;
HAL_GPIO_WritePin(GPIOB, LCD_EN, GPIO_PIN_RESET);	
HAL_GPIO_WritePin(GPIOB, LCD_RS, GPIO_PIN_SET);	
/*	
LCD_RD7 = (data1 & 0x80)>>7; LCD_RD6 = (data1 & 0x40)>>6;
LCD_RD5 = (data1 & 0x20)>>5; LCD_RD4 = (data1 & 0x10)>>4;*/
HAL_GPIO_WritePin(GPIOA, LCD_RD7,!!((data1 & 0x80)>>7) ? GPIO_PIN_SET : GPIO_PIN_RESET);
HAL_GPIO_WritePin(GPIOA, LCD_RD6,!!((data1 & 0x40)>>6) ? GPIO_PIN_SET : GPIO_PIN_RESET);
HAL_GPIO_WritePin(GPIOA, LCD_RD5,!!((data1 & 0x20)>>5) ? GPIO_PIN_SET : GPIO_PIN_RESET);
HAL_GPIO_WritePin(GPIOA, LCD_RD4,!!((data1 & 0x10)>>4) ? GPIO_PIN_SET : GPIO_PIN_RESET);	
HAL_Delay(2);	
//LCD_EN = 1; delay_us(5); LCD_EN = 0;
HAL_GPIO_WritePin(GPIOB, LCD_EN, GPIO_PIN_SET);	
delay_us(5); 	
HAL_GPIO_WritePin(GPIOB, LCD_EN, GPIO_PIN_RESET);	
/*	
LCD_RD7 = (data1 & 0x08)>>3; LCD_RD6 = (data1 & 0x04)>>2;
LCD_RD5 = (data1 & 0x02)>>1; LCD_RD4 = (data1 & 0x01);*/
HAL_GPIO_WritePin(GPIOA, LCD_RD7,!!((data1 & 0x08)>>3) ? GPIO_PIN_SET : GPIO_PIN_RESET);
HAL_GPIO_WritePin(GPIOA, LCD_RD6,!!((data1 & 0x04)>>2) ? GPIO_PIN_SET : GPIO_PIN_RESET);
HAL_GPIO_WritePin(GPIOA, LCD_RD5,!!((data1 & 0x02)>>1) ? GPIO_PIN_SET : GPIO_PIN_RESET);
HAL_GPIO_WritePin(GPIOA, LCD_RD4,!!(data1 & 0x01)? GPIO_PIN_SET : GPIO_PIN_RESET);	
HAL_Delay(2);	
//LCD_EN = 1; delay_us(5); LCD_EN = 0;
HAL_GPIO_WritePin(GPIOB, LCD_EN, GPIO_PIN_SET);	
delay_us(5); 	
HAL_GPIO_WritePin(GPIOB, LCD_EN, GPIO_PIN_RESET);	
delay_us(5); delay_us(5500);

}

void Lcd_Cmd(unsigned char data1){

//LCD_EN = 0; LCD_RS = 0;
HAL_GPIO_WritePin(GPIOB, LCD_RS|LCD_EN, GPIO_PIN_RESET);	
/*LCD_RD7 = (data1 & 0x80)>>7; LCD_RD6 = (data1 & 0x40)>>6;
LCD_RD5 = (data1 & 0x20)>>5; LCD_RD4 = (data1 & 0x10)>>4;*/
HAL_GPIO_WritePin(GPIOA, LCD_RD7,!!((data1 & 0x80)>>7) ? GPIO_PIN_SET : GPIO_PIN_RESET);
HAL_GPIO_WritePin(GPIOA, LCD_RD6,!!((data1 & 0x40)>>6) ? GPIO_PIN_SET : GPIO_PIN_RESET);
HAL_GPIO_WritePin(GPIOA, LCD_RD5,!!((data1 & 0x20)>>5) ? GPIO_PIN_SET : GPIO_PIN_RESET);
HAL_GPIO_WritePin(GPIOA, LCD_RD4,!!((data1 & 0x10)>>4) ? GPIO_PIN_SET : GPIO_PIN_RESET);	
HAL_Delay(2);
//LCD_EN = 1; delay_us(5); LCD_EN = 0;
HAL_GPIO_WritePin(GPIOB, LCD_EN, GPIO_PIN_SET);	
delay_us(5); 	
HAL_GPIO_WritePin(GPIOB, LCD_EN, GPIO_PIN_RESET);		
/*LCD_RD7 = (data1 &  0x08)>>3; LCD_RD6 = (data1 & 0x04)>>2;
LCD_RD5 = (data1 & 0x02)>>1; LCD_RD4 = (data1 & 0x01);*/
HAL_GPIO_WritePin(GPIOA, LCD_RD7,!!((data1 & 0x08)>>3) ? GPIO_PIN_SET : GPIO_PIN_RESET);
HAL_GPIO_WritePin(GPIOA, LCD_RD6,!!((data1 & 0x04)>>2) ? GPIO_PIN_SET : GPIO_PIN_RESET);
HAL_GPIO_WritePin(GPIOA, LCD_RD5,!!((data1 & 0x02)>>1) ? GPIO_PIN_SET : GPIO_PIN_RESET);
HAL_GPIO_WritePin(GPIOA, LCD_RD4,!!(data1 & 0x01)? GPIO_PIN_SET : GPIO_PIN_RESET);	
HAL_Delay(2);
//LCD_EN = 1; delay_us(5); LCD_EN = 0;
HAL_GPIO_WritePin(GPIOB, LCD_EN, GPIO_PIN_SET);	
delay_us(5); 	
HAL_GPIO_WritePin(GPIOB, LCD_EN, GPIO_PIN_RESET);	
delay_us(5500);
}
